/**
  *  \file int/if/ifutil.h
  *  \brief Interpreter Game Interface: Utilities
  */
#ifndef PCC_V2_INT_IF_IFUTIL_H
#define PCC_V2_INT_IF_IFUTIL_H

#include "cpluslib/types.h"
#include "cpluslib/string.h"

class IntValue;

/** Name mapping. */
struct TIntMapping {
    const char* name;          /**< Name of property. */
    uint16_t    index;         /**< Index of property. */
    uint16_t    domain;        /**< Domain of property. */
};

int32_t lookupName(string_t name, const TIntMapping* mapping, uint32_t size);

void checkArgumentCount(uint32_t have, uint32_t want);
void checkArgumentCount(uint32_t have, uint32_t min, uint32_t max);

bool checkIntArg(int32_t& out, IntValue* value);
bool checkIntArg(int32_t& out, IntValue* value, int32_t min, int32_t max);

#endif
