/**
  *  \file int/if/playerif.h
  *  \brief Interpreter Game Interface: Player Properties
  */
#ifndef PCC_V2_INT_IF_PLAYERIF_H
#define PCC_V2_INT_IF_PLAYERIF_H

#include "int/context.h"

class IntValue;
class IntDataSegment;

IntValue*   IFPlayerGet(IntDataSegment& dseg, uint32_t index, uint32_t nargs);
IntContext* IFPlayerMake();

/** Player context. */
class IntPlayerContext : public IntContext {
    int pid;
 public:
    IntPlayerContext(int pid);
    ~IntPlayerContext();

    // IntContext:
    int32_t   lookup(string_t name);
    void      set(int32_t index, IntValue* value);
    IntValue* get(int32_t index);
    bool      next();
    IntContext* clone();
};

/** Player properties. */
enum IntPlayerProperty {
    iplAdjName,
    iplFullName,
    iplId,
    iplMission,
    iplRaceId,
    iplTeam,
    iplShortName,
    iplScoreBases,
    iplScorePlanets,
    iplScoreShips,
    iplScore,
    iplScoreCapital,
    iplScoreFreighters
};

IntValue* getPlayerProperty(int pid, IntPlayerProperty ipl);

#endif
